LibreOffice: AccessibleShape Service Reference

LibreOffice LibreOffice 5.3 SDK API Reference

Exported Interfaces | List of all members
AccessibleShape Service Reference

The AccessibleShape service is implemented by UNO shapes to provide accessibility information that describe the shape's features. More...

`import"AccessibleShape.idl";`

Inheritance diagram for AccessibleShape:

## Exported Interfaces
interface | ::com::sun::star::accessibility::XAccessible
| Base interface for being accessible. More...
interface | ::com::sun::star::accessibility::XAccessibleContext
| Give access to the structural information of a shape. More...
interface | ::com::sun::star::accessibility::XAccessibleComponent
| Give access to the graphical representation of a shape. More...
interface | ::com::sun::star::accessibility::XAccessibleExtendedComponent
| Give extended access to the graphical representation of a shape. More...

## Additional Inherited Members
Public Member Functions inherited from XAccessible
XAccessibleContext | getAccessibleContext ()
| Returns the AccessibleContext associated with this object. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XAccessibleContext
long | getAccessibleChildCount ()
| Return the number of children. More...
XAccessible | getAccessibleChild ([in] long i) raises (::com::sun::star::lang::IndexOutOfBoundsException)
| Returns the i-th child of this object. More...
XAccessible | getAccessibleParent ()
| Returns the parent of this object. More...
long | getAccessibleIndexInParent ()
| Returns the index of this object in its accessible parent. More...
short | getAccessibleRole ()
| Returns the role of this object. More...
string | getAccessibleDescription ()
| Returns the object's description. More...
string | getAccessibleName ()
| Return the object's localized name. More...
XAccessibleRelationSet | getAccessibleRelationSet ()
| Returns the set of relations defined for this object. More...
XAccessibleStateSet | getAccessibleStateSet ()
| Returns the set of states that are currently active for this object. More...
::com::sun::star::lang::Locale | getLocale () raises (IllegalAccessibleComponentStateException)
| Returns the locale of the component. More...
Public Member Functions inherited from XAccessibleComponent
boolean | containsPoint ([in] ::com::sun::star::awt::Point Point)
| Tests whether the specified point lies within this object's bounds. More...
XAccessible | getAccessibleAtPoint ([in] ::com::sun::star::awt::Point Point)
| Returns the Accessible child that is rendered under the given point. More...
::com::sun::star::awt::Rectangle | getBounds ()
| Returns the bounding box of this object. More...
::com::sun::star::awt::Point | getLocation ()
| Returns the location of the upper left corner of the object's bounding box relative to the parent. More...
::com::sun::star::awt::Point | getLocationOnScreen ()
| Returns the location of the upper left corner of the object's bounding box in screen coordinates. More...
::com::sun::star::awt::Size | getSize ()
| Returns the size of this object's bounding box. More...
void | grabFocus ()
| Grabs the focus to this object. More...
::com::sun::star::util::Color | getForeground ()
| Returns the foreground color of this object. More...
::com::sun::star::util::Color | getBackground ()
| Returns the background color of this object. More...
Protected Member Functions inherited from XAccessibleExtendedComponent
::com::sun::star::awt::XFont | getFont ()
| Returns the font of this object. More...
string | getTitledBorderText ()
| Returns the titled border text. More...
string | getToolTipText ()
| Returns the tool tip text of this object. More...

## Detailed Description

The AccessibleShape service is implemented by UNO shapes to provide accessibility information that describe the shape's features.

A UNO shape is any object that implements the com::sun::star::drawing::XShape interface.

The content of a draw page is modelled as tree of accessible shapes and accessible text paragraphs. The root of this (sub-)tree is the accessible draw document view. An accessible shape implements either this service or one of the "derived" services AccessibleGraphicShape or AccessibleOLEShape. See the section Children in the description of the com::sun::star::accessibility::XAccessibleContext interface support for more details.

There are two services that extend this one: the AccessibleGraphicShape and the AccessibleOLEShape services provide additional interfaces. See there for details.

A shape object is either fully or partially visible on the screen or has set the com::sun::star::accessibility::AccessibleStateType::DEFUNC state to indicate that it is no longer actively supported by its parent.

Each shape object that has not set the DEFUNC state has a valid parent. That is either the containing draw page or a group shape or a 3D scene object.

Since
  OOo 1.1.2

## Exported Interfaces

## ◆ ::com::sun::star::accessibility::XAccessible

interface ::com::sun::star::accessibility::XAccessible

Base interface for being accessible.

It gives access to the com::sun::star::accessibility::XAccessibleContext interface.

## ◆ ::com::sun::star::accessibility::XAccessibleComponent

interface ::com::sun::star::accessibility::XAccessibleComponent

Give access to the graphical representation of a shape.

The bounding box returned by the com::sun::star::accessibility::XAccessibleComponent::getBounds() function returns the shape's bounding box clipped at its parent's bounding box

An accessible shape tries as best as it can to return proper values for calls to the com::sun::star::accessibility::XAccessibleExtendedComponent::getForeground() and com::sun::star::accessibility::XAccessibleExtendedComponent::getBackground() functions. If the shape is painted with a uniform and non-transparent color then the returned colors may differ from the ones visible on the screen.

Key bindings are not supported at the moment

## ◆ ::com::sun::star::accessibility::XAccessibleContext

interface ::com::sun::star::accessibility::XAccessibleContext

Give access to the structural information of a shape.

You can access the following information for the shape being made accessible:

- Role: The role of all shapes is com::sun::star::accessibility::AccessibleRole::SHAPE.
- Name: The name of a shape is its localized type name.
- Description: Descriptions are localized and start with the shape's type and style. After that follow some properties that differ from the defaults with respect to the style.
- Children: The children of a shape are either other accessible shapes or accessible text paragraphs. Only group shapes, 3D scene shapes, and OLE shapes may contain other shapes as children. Some of the shapes may have text paragraphs as (additional) children. See com::sun::star::text::AccessibleParagraphView for details of how this text is represented.
- Parent: The parent is either the document view as represented by AccessibleDrawDocumentView or a group shape, 3D scene shape, or OLE shape.
- Relations: Are set and maintained from the outside. See the service description of the object that has accessible shapes as children for details.
- States: The states supported by this service are:

  - com::sun::star::accessibility::AccessibleStateType::DEFUNC is set if an accessible shape is not visible but still existent for some reason. This should not really happen and is a sign that someone, e.g. an AT-Tool holds references to such a shape. The reason for this is that either the owner of the accessible shape did not remove it from its list of children or that the AT-Tool does not care for the events indicating this.

    Usually an object that has the com::sun::star::accessibility::AccessibleStateType::DEFUNC state set has already been disposed and subsequent calls to this object result in com::sun::star::lang::DisposedException exceptions.

    If this state is set then no other of the states below is set. This is also true for the states that are otherwise always set (which makes "always" more of a sort of "normally").

  - com::sun::star::accessibility::AccessibleStateType::EDITABLE is always set. This state is interpreted to mean that not only text but also other, graphical, properties of a shape can be modified.
  - com::sun::star::accessibility::AccessibleStateType::ENABLED is always set.
  - com::sun::star::accessibility::AccessibleStateType::FOCUSABLE is always set.
  - com::sun::star::accessibility::AccessibleStateType::FOCUSED is set according to whether the shape currently has the focus.
  - com::sun::star::accessibility::AccessibleStateType::MULTI_LINE is set if a shape supports the com::sun::star::accessibility::XAccessibleText interface.
  - com::sun::star::accessibility::AccessibleStateType::OPAQUE is set for certain shapes with certain attributes like for a filled rectangle.
  - com::sun::star::accessibility::AccessibleStateType::RESIZABLE is always set.
  - com::sun::star::accessibility::AccessibleStateType::SELECTABLE is always set.
  - com::sun::star::accessibility::AccessibleStateType::SELECTED is set according to whether the shape is currently selected.
  - com::sun::star::accessibility::AccessibleStateType::SHOWING is always set.
  - com::sun::star::accessibility::AccessibleStateType::VISIBLE is always set.
- Locale: The shape returns the locale of its parent.
- Property change listeners: Property change listeners that are registered with a shape are informed of the usual events.

## ◆ ::com::sun::star::accessibility::XAccessibleExtendedComponent

interface ::com::sun::star::accessibility::XAccessibleExtendedComponent
| optional

Give extended access to the graphical representation of a shape.

The functions com::sun::star::accessibility::XAccessibleExtendedComponent::getFont(), com::sun::star::accessibility::XAccessibleExtendedComponent::getTitledBorderText(), and com::sun::star::accessibility::XAccessibleExtendedComponent::getToolTipText() are not supported and return empty references respectively empty strings.

The support of this interface is optional to reduce overhead in case that no text is displayed and color information can not be determined with an acceptable cost.

The documentation for this service was generated from the following file:

- com/sun/star/drawing/AccessibleShape.idl